snoopbegin.onentercontext, snoopindicator.onentercontext {
	pushoutput('');
}

snoopbegin.onleavecontext, snoopindicator.onleavecontext {
	popoutput();
}

snoopdata.onentercontext {
	pushoutput(snoopoutput);
}

snoopdata.onleavecontext {
	popoutput();
}

snoopindicator.onentercontext, snoopindicator.onleavecontext {
	;
}

prompt.onentercontext {
	startprompt();
}

prompt.onleavecontext {
	endprompt();
}

startprompt {
	# This is a hack to stop the prompt being repeated after
	  sending an interrupting FE-type command #	

	if (curpos('main') == 0)
	{
		promptref = 0;
		setoutput('main');
	}
	else
	{
		if (promptref == 0)
			setoutput('');
	}				

	promptref++;
}

endprompt {
	promptref--;

	if (promptref == 0)
	{		
		if (quoting)
			print('"', '99 99');

		setoutput('main');			
	}
}

afk {
	if ((initialised == 1) && (afk != 1))
	{
		message('CLIENT: Status updates will be suspended whilst AFK');

		send('afk');
		afk = 1;

		unauto('fes');
		unauto('few');																										
	};
}

unafk {
	if ((initialised == 1) && afk)
	{
		auto('fes', 10, 'getinfo();');
		setautowho();

		message('CLIENT: You are no longer AFK');
		afk = 0;													
	};
}

setloggingon {
	setfocus('contextmenu');

	if (nologging != 0)
	{
		if (!logging)
		{
			imessage('CLIENT: Logging is now ON');

			beginlog();
			logging = 1;
		}
	};
}

setloggingoff {
	setfocus('contextmenu');	
												
	nologging = 1;
	if (logging)
	{
		imessage('CLIENT: Logging is now OFF');

		endlog();
		logging = 0;
	};
}

cmdline.onsubmit {
	if ((substr(text, 0, 1)) == '*')
	{
		execute((substr(text, 1, 512)));
		settext('cmdline', '');
		update('cmdline');
	}
	else
	{		
		if (initialised)
		{				
			if (text == '')
				{ text = lastcmd; }
	
			if (queuesv)
			{
				if ((pendinginfo == 0) && (sleeping == 0))
				{
					sendinterrupt('SV');
					pendinginfo = 1;
				}

				queuesv = 0;
			}
																	
			if ((substr(text, 0, 2) == '/"') || (substr(text, 0, 2) == '/\''))
			{				
				printcr(); 

				if (quoting)
					print('Leaving quote mode.', '99 99');								
				else
					print('Entering quote mode. Preceding commands with ". You can use /" to leave.', '99 99');

				printcr(); 
				
				quoting = !quoting;				
			}
			else
			{	
				fword = (wordat(text, 0));
												
				if (quoting)
					{ text = ('"' + text); }

				if ((privs > 0) && (fword == 'reroll'))
				{
					cscore = int(score);
					#strtoint(cscore);#

					if (score == 0)
					{
						# split(rcmd, rerolltarget, text); #
						rcmd = wordat(text, 0);
						rerolltarget = wordat(text, 1);

						ceiling(70, rerollttarget, rerollttarget);
						floor(30, rerollttarget, rerollttarget);

						reroll = 1;
						send('reroll');
					}							
					else
						{ send(text); };
				}
				else
				{
					if (fword == 'autoreattack')
					{
						if (words(text) == 1)
						{
							if (autoreattack)										
							{
								if (reattackwp)
									imessage(('CLIENT: AUTOREATTACK is using "' + reattackwp) + '"');
								else
									imessage('CLIENT: AUTOREATTACK is ON (but not using a weapon)');																				
							}
							else
								imessage('CLIENT: AUTOREATTACK is currently OFF');
						}
						else
						{	
							if (wordat(text, 1) == 'on') 
							{
								if (autoreattack)
									imessage('CLIENT: AUTOREATTACK is already enabled');
								else
								{
									imessage('CLIENT: AUTOREATTACK is now ON');
									autoreattack = 'Y';
								}										
							}
							else
							{
								if (wordat(text, 1) == 'off')
								{
									if (autoreattack)
										imessage('CLIENT: AUTOREATTACK is now OFF');
									else
										imessage('CLIENT: AUTOREATTACK is already off');

									autoreattack = '';
								}
								else
								{
									reattackwp = (substr(text, 13, 255));

									if (reattackwp ~= 'none')
									{
										reattackwp = '';

										imessage('CLIENT: AUTOREATTACK will no longer using a weapon');
									}
									else
									{
										if (autoreattack)
											imessage(('CLIENT: AUTOREATTACK is now using "' + reattackwp) + '"');
										else
											imessage(('CLIENT: AUTOREATTACK is now ON, using "' + reattackwp) + '"');
									}

									autoreattack = 'Y';
								}
							}									
						}
					}
					else
					{
						if (fword == 'autoresponse')
						{
							if ((words(text)) == 1)
							{
								if (autoresponse)
									imessage('CLIENT: AUTORESPONSE is now OFF');

								autoresponse = '';									
							}
							else
							{									
								if (autoresponse == '')
									imessage('CLIENT: AUTORESPONSE is now ON');
								else
									imessage('CLIENT: AUTORESPONSE modified');

								autoresponse = substr(text, 13, 255);
							}

							print(autoresponse, '99 99');
						}
						else
						{
							if (fword == 'alert')
							{
								unhook('alert');

								if ((words(text)) == 1)
									{ imessage('CLIENT: ALERT cancelled'); }
								else
								{
									alerttext = (substr(text, 6, 255));

									imessage('CLIENT: ALERT set');
									hook('alert', alerttext, "sfx='alert'; sfxvol=100; playsoundeffect();");
								}								
							}
							else
							{
								if ((substr(fword, 0, 3)) == 'ccm')
								{												
									if (fword == 'ccmkey')
									{
										ccmkey = (substr(text, 7, 255));
										imessage('CLIENT: CCM key set');
									}
									else
									{
										if (fword == 'ccm')
										{
											recipient = (wordat(text, 1));
											msgstart = (wordoffset(text, 2));											
																
											coded = (scramble(ccmkey, substr(text, msgstart, 255)));											

											sendinterrupt(((recipient + ' ') + coded));
										}
										else
											{ send(text); }
									}
								}
								else
									{ send(text); resleep = 0; }
							}
						}						
					}
				}

				if (afk && text)
					{ unafk(); }
			}
		}
		else
			{ send(text); }
	}

	lastcmd = text;
	clear('cmdline');
}